/*
 * z2-Environment
 * 
 * Copyright(c) ZFabrik Software GmbH & Co. KG
 * 
 * contact@zfabrik.de
 * 
 * http://www.z2-environment.eu
 */
package com.zfabrik.test.db.data;

import java.sql.Connection;
import java.time.Instant;
import java.time.temporal.ChronoUnit;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.TimeUnit;

import javax.sql.DataSource;

import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;

import com.zfabrik.components.IComponentsLookup;
import com.zfabrik.dev.z2jupiter.Z2JupiterTestable;
import com.zfabrik.impl.db.data.Module;
import com.zfabrik.work.WorkUnit;

/**
 * Tests for refs #2159
 */
@Z2JupiterTestable(componentName = Module.NAME)
@Disabled
public class ConnectionExhaustingTests {

	@Test
	public void exhaustConnections() throws Exception {
		int N = 11;
		ExecutorService tp = Executors.newFixedThreadPool(N);
		long end = Instant.now().plus(30, ChronoUnit.SECONDS).toEpochMilli();
		for (int i=0;i<N;i++) {
			tp.execute(()->{
				while (System.currentTimeMillis()<end) {
					WorkUnit.run(()->{
						DataSource ds = IComponentsLookup.INSTANCE.lookup("com.zfabrik.samples.hibernate-basic.domain/DB", DataSource.class);
						try (Connection conn = ds.getConnection()) {
							Thread.sleep(400);
						} catch (Exception e) {
							e.printStackTrace();
						} finally {
						}
					});
				}
			});
		}
		tp.shutdown();
		tp.awaitTermination(Long.MAX_VALUE, TimeUnit.MICROSECONDS);		
	}

}
