/*
 * z2-Environment
 * 
 * Copyright(c) ZFabrik Software GmbH & Co. KG
 * 
 * contact@zfabrik.de
 * 
 * http://www.z2-environment.eu
 */
package com.zfabrik.dev.z2jupiter.internal.transfer;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;

import org.junit.platform.engine.reporting.ReportEntry;

/**
 * Serialized representation of a {@link ReportEntry}
 */
public class Z2JupiterReportEntryDto implements Serializable {
	private static final long serialVersionUID = -7970478917563473638L;
	private Map<String,String> keyValuePairs;

	public Z2JupiterReportEntryDto() {}
	
	public Z2JupiterReportEntryDto(ReportEntry entry) {
		this.keyValuePairs=new HashMap<>(entry.getKeyValuePairs());
	}

	public Map<String, String> getKeyValuePairs() {
		return keyValuePairs;
	}

	public void setKeyValuePairs(Map<String, String> keyValuePairs) {
		this.keyValuePairs = keyValuePairs;
	}

	public ReportEntry toReportEntry() {
		return ReportEntry.from(this.keyValuePairs);
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((keyValuePairs == null) ? 0 : keyValuePairs.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Z2JupiterReportEntryDto other = (Z2JupiterReportEntryDto) obj;
		if (keyValuePairs == null) {
			if (other.keyValuePairs != null)
				return false;
		} else if (!keyValuePairs.equals(other.keyValuePairs))
			return false;
		return true;
	}

	@Override
	public String toString() {
		return "Z2JupiterReportEntryDto [keyValuePairs=" + keyValuePairs + "]";
	}
	
	
}
